#ifndef WORLD_H
#define WORLD_H

#include <vector>

#include "block_data.h"
#include "chunk.h"

class World
{
public:
    World();
    ~World();
    BLOCK getBlock(int x, int y, int z);
    void setBlock(int x, int y, int z, BLOCK block);
    void setPosition(int x, int y, int z);
    bool intersect(AABB &other);
    bool intersectRay(GLFix x, GLFix y, GLFix z, GLFix dx, GLFix dy, GLFix dz, Position &result, AABB::SIDE &side);
    void clear();
    bool loadFromFile(FILE *file);
    bool saveToFile(FILE *file);
    void render();

private:
    Chunk *findChunk(int x, int y, int z);
    Chunk *generateChunk(int x, int y, int z);

    static constexpr int field_of_view = 1;
    bool loaded = false;
    int cen_x = 0, cen_z = 0;

    std::vector<Chunk*> all_chunks;
    std::vector<Chunk*> visible_chunks;
};

#endif // WORLD_H
